var ModelValueConstructor_1;
import { __decorate } from "tslib";
import { apiValueConstructor } from '@a11d/api';
export const model = (typeName) => {
    return (Constructor) => {
        ModelValueConstructor.modelConstructorsByTypeName.set(typeName, Constructor);
    };
};
export let ModelValueConstructor = ModelValueConstructor_1 = class ModelValueConstructor {
    constructor() {
        this.shallConstruct = (value) => !!value && typeof value === 'object' && ModelValueConstructor_1.typeNameKey in value;
    }
    construct(object) {
        const typeName = object[ModelValueConstructor_1.typeNameKey];
        const Constructor = ModelValueConstructor_1.modelConstructorsByTypeName.get(typeName);
        return !Constructor ? object : safeAssign(new Constructor, object);
    }
};
ModelValueConstructor.modelConstructorsByTypeName = new Map();
ModelValueConstructor.typeNameKey = '@type';
ModelValueConstructor = ModelValueConstructor_1 = __decorate([
    apiValueConstructor()
], ModelValueConstructor);
function safeAssign(target, source) {
    const safeSource = Object.fromEntries(Object.entries(source).reduce((accumulator, currentValue) => {
        const descriptor = Object.getOwnPropertyDescriptor(Object.getPrototypeOf(target), currentValue[0]);
        if (!descriptor || descriptor.set) {
            accumulator.push(currentValue);
        }
        return accumulator;
    }, new Array()));
    return Object.assign(target, safeSource);
}
